#import "DrawXYTRF.h"

@implementation DrawXYTRF

- (void)setRightImage:(double ***)st_filter time:(int)t
{
    double amp_xytview = 250.0;//  st_filter:Normalized Value
	int x, y, iByteRow;
    int magx, magy;
    int sizex = 100;
    int sizey = 100;
    unsigned char *simData; //*rfBitmap;
    simData = (unsigned char *)malloc(sizex*sizey*3);
    memset( simData, 0, sizex*sizey*3);
    
    NSBitmapImageRep *bmpImageRep = [[NSBitmapImageRep alloc] 
    initWithBitmapDataPlanes:&simData    //@@rbg}bv摜w肵ŏ
    pixelsWide:sizex                     //@@
    pixelsHigh:sizey                     //@@
    bitsPerSample:8                      //@@𑜓x@bit/pixel
    samplesPerPixel:3                    //@@sample/pixel
    hasAlpha:NO                          //@@At@`l̗L YES/NO
    isPlanar:NO                          //@@v[z
    colorSpaceName:NSDeviceRGBColorSpace //@@@J[Xy[X
    bytesPerRow:sizex*3                  //@@P̃oCg
    bitsPerPixel:24];                    //@@bit/pixel
    
    unsigned char *pixelData;
    pixelData = [ bmpImageRep bitmapData];
    iByteRow = [ bmpImageRep bytesPerRow ];
    
	for ( y=0; y<RF_height; y++ ) {
        for ( x=0; x<RF_width; x++ ) {
            if ( *(*(*(st_filter+(RF_time-1-t))+x)+y)>=0.0 ) {
                for ( magy=0; magy<5; magy++ ) {
                    for ( magx=0; magx<5; magx++ ) {
                        *(pixelData+ (5*x+magx)*3  +(5*y+magy)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                        *(pixelData+(5*x+magx)*3+1 +(5*y+magy)*iByteRow) = (unsigned char)(*(*(*(st_filter+(RF_time-1-t))+x)+y)*amp_xytview);
                        *(pixelData+(5*x+magx)*3+2 +(5*y+magy)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];@@@@
                        
                        //fprintf(stderr,"%d %d %d  %f",x,y,t,*(*(*(st_filter+t)+x)+y));
                    }
                }
            } else {
                for ( magy=0; magy<5; magy++ ) {
                    for ( magx=0; magx<5; magx++ ) {
                        *(pixelData+ (5*x+magx)*3  +(5*y+magy)*iByteRow) = (unsigned char)(*(*(*(st_filter+(RF_time-1-t))+x)+y)*(-amp_xytview));
                        *(pixelData+(5*x+magx)*3+1 +(5*y+magy)*iByteRow) = (unsigned char)0;//(2*receptiveField[x][y][t]);
                        *(pixelData+(5*x+magx)*3+2 +(5*y+magy)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                    }
                }
            }
        }
    }
    
    NSImage *img = [ [ NSImage alloc ] initWithSize : [ bmpImageRep size ] ]; 
    [ img addRepresentation:bmpImageRep];
    [ bmpImageRep release];
    [ xytView setImage:img ];
    [ xytView setImageScaling:NSScaleToFit ];
    
    [ xytView display];
    [ img release ];

}


@end
