#import "SetRF.h"

#define RF_width 20
#define RF_height 20
#define RF_time 21

int receptiveField[RF_width][RF_height][RF_time];

@implementation SetRF

- (void)openData
{
    NSArray	*fileTypes 	= [ NSArray arrayWithObject:@"txt" ];
    NSOpenPanel	*op		= [ NSOpenPanel openPanel ];
    int		iSts;
    NSString	*string;    
    
    int x, y, t;
	//int receptiveField_max = 0;
    NSCharacterSet* chSet;
    NSString* scannedName;
        NSScanner* scanner;
    // f[^I
    iSts = [ op runModalForDirectory : NSHomeDirectory() 
                                file : @"Desktop" 
                                types: fileTypes /*txt*/];
    
    if ( iSts == NSOKButton ) { // Data̓ǂݍ
        string = [ [ NSString alloc ] initWithContentsOfFile: [ op filename ] ];
        
        // g[N
        //NSCharacterSet* chSet;
        //NSString* scannedName;
        //NSScanner* scanner;
        
        chSet = [NSCharacterSet characterSetWithCharactersInString:@", "];
        scanner = [NSScanner scannerWithString:string];
        
        for ( t=0; t<RF_time&&![scanner isAtEnd]; t++ ) {
            for ( y=0; y<RF_height&&![scanner isAtEnd]; y++ ) {
                for ( x=0; x<RF_width&&![scanner isAtEnd]; x++ ) {
                    if([scanner scanUpToCharactersFromSet:chSet intoString:&scannedName]) {
                        receptiveField[x][y][t]=[scannedName intValue];
                        //printf("%d ", receptiveField[x][y][t]);
						
						/*if (receptiveField[x][y][t] > receptiveField_max){
							receptiveField_max = receptiveField[x][y][t];
						}*/
                    }
                }
            }
        }
		/*for (t=0; t<RF_time;t++){
			for (y=0; y<RF_height; y++){
				for (x=0; x<RF_width; x++){
					receptiveField[x][y][t] = receptiveField[x][y][t]/receptiveField_max;
				}
			}
		}*/
    }
    
    [ self setImage_time:0 ];
}

- (void)setImage_time:(int)t
{
    int x, y, iByteRow;
    int magx, magy;
    int sizex = 100;
    int sizey = 100;
    unsigned char *simData; //*rfBitmap;
    simData = (unsigned char *)malloc(sizex*sizey*3);
    memset( simData, 0, sizex*sizey*3);
	//double amp_setView =128.0;
    
    NSBitmapImageRep *bmpImageRep = [[[NSBitmapImageRep alloc] 
    initWithBitmapDataPlanes:&simData    //@@rbg}bv摜w肵ŏ
    pixelsWide:sizex                     //@@
    pixelsHigh:sizey                     //@@
    bitsPerSample:8                      //@@𑜓x@bit/pixel
    samplesPerPixel:3                    //@@sample/pixel
    hasAlpha:NO                          //@@At@`l̗L YES/NO
    isPlanar:NO                          //@@v[z
    colorSpaceName:NSDeviceRGBColorSpace //@@@J[Xy[X
    bytesPerRow:sizex*3                  //@@P̃oCg
    bitsPerPixel:24]                     //@@bit/pixel
    retain];
    
    unsigned char *pixelData;
    pixelData = [ bmpImageRep bitmapData];
    iByteRow = [ bmpImageRep bytesPerRow ];

    
    for ( y=0; y<RF_height; y++ ) {
        for ( x=0; x<RF_width; x++ ) {
            if ( receptiveField[x][y][t]>=0 ) {
                for ( magy=0; magy<5; magy++ ) {
                    for ( magx=0; magx<5; magx++ ) {
                        *(pixelData+ (5*x+magx)*3  +(5*y+magy)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                        *(pixelData+(5*x+magx)*3+1 +(5*y+magy)*iByteRow) = (unsigned char)(receptiveField[x][y][t]);
                        *(pixelData+(5*x+magx)*3+2 +(5*y+magy)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                    }
                }
            } else {
                for ( magy=0; magy<5; magy++ ) {
                    for ( magx=0; magx<5; magx++ ) {
                        *(pixelData+ (5*x+magx)*3  +(5*y+magy)*iByteRow) = (unsigned char)(-1*receptiveField[x][y][t]);
                        *(pixelData+(5*x+magx)*3+1 +(5*y+magy)*iByteRow) = (unsigned char)0;//(2*receptiveField[x][y][t]);
                        *(pixelData+(5*x+magx)*3+2 +(5*y+magy)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                    }
                }
            }
        }
    }
	
    NSImage *img;
    img = [ [ [ NSImage alloc ] initWithSize : [ bmpImageRep size ] ] autorelease ]; 
    [ img addRepresentation:bmpImageRep];
	[bmpImageRep release];
    [ setxytView setImage:img ];
    [ setxytView setImageScaling:NSScaleToFit ];
    
    [setxytView display];
}

- (int)return_RF_x:(int)ix y:(int)iy
{
    return receptiveField[ix][iy][4];
}

- (void)set_RFarray:(double ***)st_filter
{
	int x, y, t;
	double RF_max = 0.00000000001;
	
	for (t=0; t<RF_time; t++){
		for (y=0; y<RF_height; y++){
			for (x=0; x<RF_width; x++){
				*(*(*(st_filter+RF_time-t-1)+x)+y) = receptiveField[x][y][t];
				
				if (*(*(*(st_filter+RF_time-t-1)+x)+y) > RF_max){
					RF_max = *(*(*(st_filter+RF_time-t-1)+x)+y);
				}
			}
		}
	}
	for (t=0; t<RF_time; t++){
		for (y=0; y<RF_height; y++){
			for (x=0; x<RF_width; x++){
				*(*(*(st_filter+RF_time-t-1)+x)+y) = *(*(*(st_filter+RF_time-t-1)+x)+y)/RF_max;				
			}
		}
	}
}

- (void)setbuttonxtView:(double ***)st_filter
{
	int x, y, t, i;
	
	xtdata = malloc(sizeof(double*)*RF_time);
    for (i=0; i<RF_time; i++){
        *(xtdata+i) = malloc(sizeof(double)*RF_width);
    }
    for (t=0; t<RF_time; t++){
        for (x=0; x<RF_width; x++){
            *(*(xtdata+t)+x) = 0.0;        
        }
    }

    for (t=0; t<RF_time; t++){
        for (x=0; x<RF_width; x++){
            for (y=0; y<RF_height; y++){
                *(*(xtdata+t)+x) = *(*(xtdata+t)+x) +(*(*(*(st_filter+t)+x)+y)); 
            }
        }
    }
    /*for (t=0; t<RF_time; t++){
        for (x=0; x<RF_width; x++){
            fprintf(stderr,"%d %d %f \n",t,x,*(*(xtdata+t)+x) );
        }
    }*/
    
    int iByteRow;
    int magx, magt;
    int sizex = 100;
    int sizet = 100;
    unsigned char *simData; //*rfBitmap;
    simData = (unsigned char *)malloc(sizex*sizet*3);
    memset( simData, 0, sizex*sizet*3);
	//double amp_set_xtView = 128.0;
    
    NSBitmapImageRep *bmpImageRep = [[[NSBitmapImageRep alloc] 
    initWithBitmapDataPlanes:&simData    //@@rbg}bv摜w肵ŏ
    pixelsWide:sizex                     //@@
    pixelsHigh:sizet                     //@@
    bitsPerSample:8                      //@@𑜓x@bit/pixel
    samplesPerPixel:3                    //@@sample/pixel
    hasAlpha:NO                          //@@At@`l̗L YES/NO
    isPlanar:NO                          //@@v[z
    colorSpaceName:NSDeviceRGBColorSpace //@@@J[Xy[X
    bytesPerRow:sizex*3                  //@@P̃oCg
    bitsPerPixel:24]                     //@@bit/pixel
    retain];
    
    unsigned char *pixelData;
    pixelData = [ bmpImageRep bitmapData];
    iByteRow = [ bmpImageRep bytesPerRow ];

    
    for ( t=0; t<RF_time; t++ ) {
        for ( x=0; x<RF_width; x++ ) {
            if ( *(*(xtdata+t)+x)>=0.0 ) {
                for ( magt=0; magt<5; magt++ ) {
                    for ( magx=0; magx<5; magx++ ) {
                        *(pixelData+ (5*x+magx)*3  +(5*t+magt)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                        *(pixelData+(5*x+magx)*3+1 +(5*t+magt)*iByteRow) = (unsigned char)((*(*(xtdata+t)+x)))*20.0;
                        *(pixelData+(5*x+magx)*3+2 +(5*t+magt)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                    }
                }
            } else {
                for ( magt=0; magt<5; magt++) {
                    for ( magx=0; magx<5; magx++ ) {
                        *(pixelData+ (5*x+magx)*3  +(5*t+magt)*iByteRow) = (unsigned char)(-1.0*(*(*(xtdata+t)+x)))*20.0;
                        *(pixelData+(5*x+magx)*3+1 +(5*t+magt)*iByteRow) = (unsigned char)0;//(2*receptiveField[x][y][t]);
                        *(pixelData+(5*x+magx)*3+2 +(5*t+magt)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                    }
                }
            }
        }
    }
    
    NSImage *img;
    img = [ [ [ NSImage alloc ] initWithSize : [ bmpImageRep size ] ] autorelease ]; 
    [ img addRepresentation:bmpImageRep];
    [ setxtView setImage:img ];
    [ setxtView setImageScaling:NSScaleToFit ];
    
    [setxtView display];

}

@end
