#import "gxView.h"

@implementation gxView

- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		// Add initialization code here
	}
	return self;
}

- (void)drawRect:(NSRect)rect
{
	int i;
    NSBezierPath* bezier1 = [NSBezierPath bezierPath];
    NSBezierPath* bezier2 = [NSBezierPath bezierPath];
    NSBezierPath* bezier_x = [NSBezierPath bezierPath];
    NSBezierPath* bezier_y = [NSBezierPath bezierPath];
    
	// draw x, y axis
    [bezier_x moveToPoint:NSMakePoint(0, 75) ];
    [bezier_y moveToPoint:NSMakePoint(75, 0) ];
    [bezier_x lineToPoint:NSMakePoint(150, 75) ];
    [bezier_y lineToPoint:NSMakePoint(75,150) ];
    [bezier_x stroke];
    [bezier_y stroke];
    
	// draw graph
	// ŃXP[Oׂ ( }75@-> }20 )
    [bezier1 moveToPoint:NSMakePoint(0, 75+[self spatio_filter1:-75.0*0.133/**/]) ];  // 0.133 = 20/150
    [bezier2 moveToPoint:NSMakePoint(0, 75+[self spatio_filter2:-75.0*0.133]) ];
    for (i=0; i<rect.size.width;i++){
        [bezier1 lineToPoint:NSMakePoint(i, 75+[self spatio_filter1:0.133*(i-75.0)/**/]) ];
        [bezier2 lineToPoint:NSMakePoint(i, 75+[self spatio_filter2:(i-75.0)*0.133]) ];
    }
    [[NSColor redColor] set];
    [bezier2 stroke];
    [[NSColor blueColor] set];
    [bezier1 stroke];
}

- (double)spatio_filter1:(double)x
{
	// ̎́ASpatiotemporalFilter.mŋLqeƓɂ邱
    double amp_g = 50.0;
	double amp_x = 0.1;
	
    x1 = amp_x *x;
    
    return amp_g * pow(2.71828, -2.0*(x1*x1/sigmax/sigmax)) * cos(2*3.1415*(f*x1 + phase_g/360));
}

- (double)spatio_filter2:(double)x
{
    double amp_g = 50.0;
    x1 = x;
    
    return amp_g * pow(2.71828, -2.0*0.01*(x1*x1/sigmax/sigmax)) * cos(2*3.1415*(0.1*f*x1 + phase_g/360 + fai_g/360));
}

- (void)set_sigmax:(double)sigmax1 f:(double)f1 phase_g:(double)phase_g1 fai_g:(double)fai_g1
{
    sigmax = sigmax1;
    f = f1;
    phase_g = phase_g1;
    fai_g = fai_g1;
}

@end
