#import "htView.h"

@implementation htView

- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		// Add initialization code here
	}
	return self;
}

- (void)drawRect:(NSRect)rect
{
    NSBezierPath* bezier1 = [NSBezierPath bezierPath];
    NSBezierPath* bezier2 = [NSBezierPath bezierPath];
    NSBezierPath* bezier_t = [NSBezierPath bezierPath];
    NSBezierPath* bezier_h = [NSBezierPath bezierPath];
    
    int i;
    tau = 0.005*tau;//т̃Wݒ
    
    [bezier1 moveToPoint:NSMakePoint(0, 75+[self temp_filter1:0]) ];
    [bezier2 moveToPoint:NSMakePoint(0, 75+[self temp_filter2:0]) ];
    [bezier_t moveToPoint:NSMakePoint(0, 75) ];
    [bezier_h moveToPoint:NSMakePoint(0, 0) ];
    
    [bezier_t lineToPoint:NSMakePoint(150, 75) ];
    [bezier_t stroke];
    [bezier_h lineToPoint:NSMakePoint(0,150) ];
    [bezier_h stroke];
    
    for(i = 1; i < rect.size.width;i++){
        [bezier1 lineToPoint : NSMakePoint(i, 75+[self temp_filter1:0.004*i]) ];//0.0040.002
        [bezier2 lineToPoint : NSMakePoint(i, 75+[self temp_filter2:0.004*i]) ];
    }
    [ [ NSColor blueColor ] set ];
    [bezier1 stroke];
    [ [ NSColor redColor] set ];
    [bezier2 stroke];
}

- (double)temp_filter1:(double)t
{
    double amp_tf = 7.0;//KȐUݒ
    return amp_tf * t/tau/tau*pow(2.71828,-t/tau)*cos(omega*t+phase_h*3.141592/180.0);
}

- (double)temp_filter2:(double)t
{
    double amp_tf = 7.0;//KȐUݒ
    return amp_tf * t/tau/tau*pow(2.71828,-t/tau)*cos(omega*t+phase_h*3.141592/180+fai_h*3.141592/180);
}

- (void)set_tau:(double)tau1 omega:(double)omega1 phase_h:(double)phase_h1 fai_h:(double)fai_h1
{
    tau = tau1;
    omega = omega1;
    phase_h = phase_h1;
    fai_h = fai_h1;
}

- (double)tau
{
    return tau;
}

- (double)omega
{
    return omega;
}

- (double)phase_h
{
    return phase_h;
}

- (double)fai_h
{
    return fai_h;
}

@end
