#import "DrawXTRF.h"

@implementation DrawXTRF

- (void)setxtView:(double **)xt_function
{
    double amp_xtview = 250.0;//  xt_function:Normalized Value
	int x, t, iByteRow;
    int magx, magt;
    int sizex = 100;
    int sizet = 105;
    unsigned char *simData; //*rfBitmap;
    simData = (unsigned char *)malloc(sizex*sizet*3);
    memset( simData, 0, sizex*sizet*3);
    
    NSBitmapImageRep *bmpImageRep = [[NSBitmapImageRep alloc] 
    initWithBitmapDataPlanes:&simData    //@@rbg}bv摜w肵ŏ
    pixelsWide:sizex                     //@@
    pixelsHigh:sizet                     //@@
    bitsPerSample:8                      //@@𑜓x@bit/pixel
    samplesPerPixel:3                    //@@sample/pixel
    hasAlpha:NO                          //@@At@`l̗L YES/NO
    isPlanar:NO                          //@@v[z
    colorSpaceName:NSDeviceRGBColorSpace //@@@J[Xy[X
    bytesPerRow:sizex*3                  //@@P̃oCg
    bitsPerPixel:24];                   //@@bit/pixel
    
    unsigned char *pixelData;
    pixelData = [ bmpImageRep bitmapData];
    iByteRow = [ bmpImageRep bytesPerRow ];

    
	//for ( t=RF_time-1; t>=0; t-- ) {
	for ( t=0; t<RF_time; t++ ) {
        for ( x=0; x<RF_width; x++ ) {
            if ( *(*(xt_function+x)+(RF_time-t-1))>=0.0 ) {
                for ( magt=0; magt<5; magt++ ) {
                    for ( magx=0; magx<5; magx++ ) {
                        *(pixelData+ (5*x+magx)*3  +(5*t+magt)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                        *(pixelData+(5*x+magx)*3+1 +(5*t+magt)*iByteRow) = (unsigned char)((*(*(xt_function+x)+(RF_time-t-1)))*amp_xtview);
                        *(pixelData+(5*x+magx)*3+2 +(5*t+magt)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                    }
                }
            } else {
                for ( magt=0; magt<5; magt++ ) {
                    for ( magx=0; magx<5; magx++ ) {
                        *(pixelData+ (5*x+magx)*3  +(5*t+magt)*iByteRow) = (unsigned char)((*(*(xt_function+x)+(RF_time-t-1)))*(-1)*amp_xtview);
                        *(pixelData+(5*x+magx)*3+1 +(5*t+magt)*iByteRow) = (unsigned char)0;//(2*receptiveField[x][y][t]);
                        *(pixelData+(5*x+magx)*3+2 +(5*t+magt)*iByteRow) = (unsigned char)0;//receptiveField[x][y][t];
                    }
                }
            }
        }
    }
    
    NSImage *img;
    img = [ [ [ NSImage alloc ] initWithSize : [ bmpImageRep size ] ] autorelease ]; 
    [ img addRepresentation:bmpImageRep];
    [ bmpImageRep release];
    [ xtView setImage:img ];
    [ xtView setImageScaling:NSScaleToFit ];
    
    [ xtView display];
    

}


@end
