#import "input_area.h"

@implementation input_area

- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		// Add initialization code here
	}
	return self;
}

- (void)set_input_area_sita:(double)sita1
{
	sita = sita1;
}

- (void)drawRect:(NSRect)rect
{
	NSBezierPath* bezier1 = [NSBezierPath bezierPath];
	NSBezierPath* bezier2 = [NSBezierPath bezierPath];
	NSBezierPath* bezier3 = [NSBezierPath bezierPath];
	NSBezierPath* bezier4 = [NSBezierPath bezierPath];
	
	[bezier1 moveToPoint:NSMakePoint(120-20*sin(2*3.1415*sita/360.0), 160+20*cos(2*3.1415*sita/360.0)) ];
	[bezier2 moveToPoint:NSMakePoint(120-20*sin(2*3.1415*sita/360.0), 160-20*cos(2*3.1415*sita/360.0)) ];
	[bezier3 moveToPoint:NSMakePoint(120+20*cos(2*3.1415*sita/360.0), 160+20*sin(2*3.1415*sita/360.0)) ];
	[bezier4 moveToPoint:NSMakePoint(120-20*cos(2*3.1415*sita/360.0), 160-20*sin(2*3.1415*sita/360.0)) ];
	
	[bezier1 lineToPoint : NSMakePoint(120-40*sin(2*3.1415*sita/360.0), 160+40*cos(2*3.1415*sita/360.0)) ];
	[bezier2 lineToPoint : NSMakePoint(120-40*sin(2*3.1415*sita/360.0), 160-40*cos(2*3.1415*sita/360.0)) ];
	[bezier3 lineToPoint : NSMakePoint(120+30*cos(2*3.1415*sita/360.0), 160+30*sin(2*3.1415*sita/360.0)) ];
	[bezier4 lineToPoint : NSMakePoint(120-30*cos(2*3.1415*sita/360.0), 160-30*sin(2*3.1415*sita/360.0)) ];
	
	[ [ NSColor redColor ] set ];
	[bezier1 stroke];
	[bezier2 stroke];
	[bezier3 stroke];
	[bezier4 stroke];

}

@end
